package chartviewwrapper;

import main.java.com.dacer.androidcharts.BarView;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

import java.util.ArrayList;
import main.java.com.dacer.androidcharts.PieHelper;

@Author("Johan Schoeman")
//@Version(1.00f)
@ShortName("BarView")
public class barViewWrapper extends ViewWrapper<BarView> implements DesignerCustomView  {


	private BA ba;
	private String eventName;
        private BarView cv;
 
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new BarView(ba.context);
                this.setObject(cv);
//                addListener();
 	}


//    @Hide
//    public void addListener(){
//        cv.setCallback(new PieView.Callback() {
//            @Override
//            public void pie_clicked() {

//              if (ba.subExists(eventName + "_pie_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_pie_clicked", true, new Object[0]);
//              }
//            }
//        });
//    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}


    public void setDataList(int[] barvalues){
        ArrayList<Integer> barDataList = new ArrayList<Integer>();
        for (int i = 0 ; i < barvalues.length ; i++){
            barDataList.add(barvalues[i]);
        }
        cv.setDataList(barDataList,100);
        cv.invalidate();
    }

    public void setBottomTextList(String[] bottomStringList){
        ArrayList<String> barBottomTextList = new ArrayList<String>();
        for (int i = 0 ; i < bottomStringList.length ; i++){
            barBottomTextList.add(bottomStringList[i]);
        }
        cv.setBottomTextList(barBottomTextList);
        cv.invalidate();
    }

    public void setBarBackgroundColor(int backcolor){
        cv.setBarBackgroundColor(backcolor);
        cv.invalidate();
    }

    public void setBarForegroundColor(int forecolor){
        cv.setBarForegroundColor(forecolor);
        cv.invalidate();
    }

    public void setBarTextColor(int bartextcolor){
        cv.setBarTextColor(bartextcolor);
        cv.invalidate();
    }

    public void setBarTextSize(float bartextsize){
        cv.setBarTextSize(bartextsize);
        cv.invalidate();
    }



}
