package chartviewwrapper;

import main.java.com.dacer.androidcharts.PieView;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

import java.util.ArrayList;
import main.java.com.dacer.androidcharts.PieHelper;

@Author("Johan Schoeman")
@Version(1.00f)
@ShortName("PieView")
public class pieViewWrapper extends ViewWrapper<PieView> implements DesignerCustomView  {


	private BA ba;
	private String eventName;
        private PieView cv;
 
	
	/*
	 * Initialize the HTML-TextView 
	 */   


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new PieView(ba.context);
                this.setObject(cv);
                addListener();
 	}


    @Hide
    public void addListener(){
        cv.setCallback(new PieView.Callback() {
            @Override
            public void pie_clicked() {

              if (ba.subExists(eventName + "_pie_clicked")) {
                ba.raiseEvent2(ba, false, eventName + "_pie_clicked", true, new Object[0]);
              }
            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_started")) {
//                ba.raiseEvent2(ba, false, eventName + "_started", true, new Object[0]);
//              }
//            }
        });
    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}

	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}

    public void setShowPercentLabel(boolean show){
        cv.showPercentLabel(show);
        cv.invalidate();
    }


    public void setData(float[] pievalues){
        ArrayList<PieHelper> pieHelperArrayList = new ArrayList<PieHelper>();
        for (int i = 0 ; i < pievalues.length ; i++){
            pieHelperArrayList.add(new PieHelper(pievalues[i]));
        }

        cv.setDate(pieHelperArrayList);
        cv.invalidate();
    }


    public void selectedPie(int index){
        cv.selectedPie(index);
        cv.invalidate();
    }

//    public void removeSelectedPie(){
//        cv.removeSelectedPie();
//        cv.invalidate();
//    }

    public void setPieColors(int[] piecolors){
        cv.setPieColors(piecolors);
        cv.invalidate();
    }

    public int getPieClickedIndex() {
        return cv.getPieClickedIndex();
    }

    public void setPieTextColor(int pietextcolor){
        cv.setPieTextColor(pietextcolor);
        cv.invalidate();
    }



}
